/*
 * Command-line parsing library
 * Copyright (c) 1996 by FRIENDS software
 * Portability: Excellent
 */

#include <string.h>
#include <malloc.h>
#include "strop.h"
#include "cmdline.h"

char *CmdLine(int argc, char *argv[])
{
 int i, Len = 0;
 char *Line;
 argc--;

 for (i = 1; i <= argc; i++)
  Len += strlen(argv[i]) + 1;
 Line = malloc(Len);
 Len = 0;
 for (i = 1; i <= argc; i++)
 {
  memcpy(&Line[Len], argv[i], strlen(argv[i]));
  Len += strlen(argv[i]) + 1;
  Line[Len - 1] = i < argc ? ' ' : 0;
 }
 return Line;
}

void ParseCmdLine(char *Line, int (*Opt)(char *), int (*Str)(char *))
{
 int len;
 char *tmp;
 if (!Line) return;
 memcpy(tmp = malloc(len = strlen(Line)), Line, len + 1);
 while (tmp[0])
 {
  int dc;
  dc = 0;
  while ((tmp[dc]) && ((tmp[dc] == SPACE) || (tmp[dc] == TAB))) dc++;
  strdel(tmp, 0, dc);
  if (tmp[0] == '-')
   { if (&Opt) dc = Opt(tmp); else dc = 1; }
  else
   { if (&Str) dc = Str(tmp); else dc = 1; }
  strdel(tmp, 0, dc);
 }
 free(tmp);
}

int OptState(char Switch, boolean *State)
{
 switch (Switch)
 {
  case '-':
   *State = FALSE; return 1;
  case '+':
   *State = TRUE; return 1;
  default:
   *State = TRUE; return 0;
 }
}
