/*
 * OS/2 console control routines
 * Copyright (c) 1997 by FRIENDS software
 * Portability: extremely low
 */

#define INCL_SUB
#include <os2.h>
#include "os2con.h"

#include <conio.h>
#include <stdio.h>

// Enable (1) or disable (0) ANSI output
boolean ANSI = TRUE;

static int ANSI2VIO[17] =
{-1, 0, 4, 2, 6, 1, 5, 3, 7, 8, 12, 10, 14, 9, 13, 11, 15};

void SetColor(int Fore, int Back)
{
 if (!ANSI || (Fore < colSAME) || (Fore > colWHITE) || (Back < colSAME) || (Back > colWHITE))
  return;

 Fore = ANSI2VIO[++Fore];
 Back = ANSI2VIO[++Back];

 if ((Fore != colSAME) && (Back != colSAME))
  printf("\x1b[%d;3%d;4%dm", Fore/8, Fore%8, Back%8);
 else if (Fore != colSAME)
  printf("\x1b[%d;3%dm", Fore/8, Fore%8);
 else if (Back != colSAME)
  printf("\x1b[4%dm", Back%8);
}

void GetConsoleSize(int *Width, int *Height)
{
 VIOMODEINFO vi;
 vi.cb = sizeof(vi);
 VioGetMode(&vi, 0);
 *Width = vi.col;
 *Height = vi.row;
}

void ClearConsole(int Attr)
{
 static char clsAttr[2];
 VIOMODEINFO vi;

 clsAttr[0] = ' ';
 if (Attr == colSAME)
  clsAttr[1] = 0x07;
 else
  clsAttr[1] = ANSI2VIO[(Attr & 0x0f) + 1] | ANSI2VIO[(Attr >> 4) + 1] << 4;
 vi.cb = sizeof(vi);
 VioGetMode(&vi, 0);
 VioScrollUp(0, 0, vi.row, vi.col, vi.col, (PBYTE)&clsAttr, 0);

 SetCursorPos(0, 0);
}

void SetConsoleSize(int Width, int Height, int Attr)
{
 VIOMODEINFO vi;
 vi.cb = sizeof(vi);
 VioGetMode(&vi, 0);

 vi.col = Width;
 vi.row = Height;
 vi.cb = sizeof(vi.cb) + sizeof(vi.fbType) + sizeof(vi.color) + \
         sizeof(vi.col) + sizeof(vi.row);
 VioSetMode(&vi, 0);
 ClearConsole(Attr);
}

void SetCursorPos(int X, int Y)
{
 VioSetCurPos(Y, X, 0);
}
