/******************************************************************************
 *
 * Customized windowed session starter
 * Copyright (C) 1997 by FRIENDS software
 * All Rights Reserved
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 ******************************************************************************/
#define INCL_DOS
#define INCL_DOSERRORS
#include <os2.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include <malloc.h>
#include <process.h>
#include "syslib.h"
#include "cmdline.h"
#include "strop.h"
#include "os2con.h"

char *version = "0.0.1";

// Shield:sInitialShape structure
// Does somebody know what those fields means?
struct
{
 USHORT unknown1;
 USHORT WindowH;
 USHORT WindowW;
 USHORT WindowY;
 USHORT WindowX;
 USHORT unknown2;
 USHORT unknown3;
 USHORT unknown4;
 USHORT unknown5;
} DefShape;

struct
{
 signed char W;
 signed char H;
} Font, DefFont;

struct
{
 int W;
 int H;
} Console;

boolean fQueryCommand = FALSE;
boolean fSecondLayer = FALSE;
boolean fDelay = FALSE;
USHORT fMaximize;
STARTDATA sd;
char *cmdLine;
static char *progname = NULL;
static char *progargs = NULL;

static long INIpresent = 0;
#define iniShape    0x00000001
#define iniMaximize 0x00000002
#define iniFontsize 0x00000004

void doHeader()
{
 static char AlreadyPrinted = 0;
 if (fSecondLayer || AlreadyPrinted) return;
 AlreadyPrinted = 1;
 SetColor(colWHITE, colSAME);
 printf("[ wOpen ][ Version %s ]\n", version);
 printf(" Copyright (C) 1997 by FRIENDS software  All Rights Reserved \n");
}

void doHelp()
{
 char *HelpText[] =
 {
  " This utility will start a windowed session (DOS or OS/2) optionaly",
  " placing window at a specific location, changing its font and resizing",
  " You can place legal switches in the WOPEN environment variable",
  " Usage: wOpen {options} {program} {...program options...}",
  " Available options:",
  " -a{+|-}",
  "  Turn on (+)/off (-) ANSI colored output",
  " -d{+|-}",
  "  Enable (+) or disable (-) a small delay after running command",
  "  Use this if you experience problems with -p switch",
  " -f{w,h}",
  "  Set window font [W]idth and [H]eight",
  " -o{c|v|x|m|b}{+|-}",
  "  Enable (+) or disable (-) one of following [O]ptions:",
  "  auto[C]lose on termination, [V]isible window,",
  "  start session ma[X]imized or [M]inimized,",
  "  run session in [B]ackground (+) or foreground (-)",
  " -p{{x}{,{y}{,{w}{,h}}}}",
  "  Set window position (X, Y) and size (W, H) (in pixels)",
  " -s{w,h}",
  "  re[S]ize window using \"MODE W,H\" command.",
  "  This enforces the -to option since DOS sessions cannot be resized",
  " -t{a|d|o}",
  "  Windowed session type: [D]OS/[O]S2/[A]utodetect; default = OS/2",
  " -q",
  "  Display a sample command line to start a window with current",
  "  size/shape (possibly modified by command-line options)",
  " -@",
  "  Don`t start a new session, just set window size (if -s is used)",
  "  then launch program. This option should be FIRST in the command line",
  "ô Default: -a+ -d- -oc+ -ov- -ox- -om- -ob- -to",
  "ô Example: wOpen -to -f10,18 -p200,100 t-mail.exe",
  "ô          wOpen -s40,25 -p,,300,100 -f8,8 -oc- *",
  "ô          wOpen -s60,20 -p10,10,488,186 -f8,8 -ob *",
  NULL
 };

 int i, linecnt, consoleH;

 fSecondLayer = FALSE;
 GetConsoleSize(&i, &consoleH); 
 linecnt = consoleH - 2;

 doHeader();
 for (i = 0; i < 999; i++)
 {
  char *Line = HelpText[i];
  if (Line == NULL) break;
  switch (Line[0])
  {
   case '':
    if (Line[2] == ' ') SetColor(colLBLUE, colSAME); else SetColor(colYELLOW, colSAME);
    break;
   case '':
    if (Line[1] == ' ') SetColor(colLCYAN, colSAME); else SetColor(colBLUE, colSAME);
    break;
  }
  printf("%s\n", Line);
  if (--linecnt <= 1)
  {
   SetColor(colWHITE, colSAME);
   printf("-- [press any key] --");
   fflush(stdout);
   getch();
   printf("\r                     \r");
   linecnt = consoleH;
  }
 }
 fflush(stdout);
}

void Stop(int code, char *msg)
{
 int cl;
 int mcl;

 doHeader();
 switch (code)
 {
  case 1:
   doHelp();
   break;
  case 2:
   cl = strlen(cmdLine);
   mcl = strlen(msg);
   cmdLine[cl - mcl] = 0;
   SetColor(colYELLOW, colSAME); printf(" Error in command-line option:\n %s", cmdLine);
   SetColor(colLRED, colSAME); printf("%s\n", msg);
   break;
 }
 SetColor(colBLUE, colSAME);
 printf(" Done\n");
 SetColor(colCYAN, colSAME);
 exit(code);
}

int OptH(char *Opt)
{
 int optLen = 2;
 boolean State;

 switch (Opt[1])
 {
  case 'a':
   optLen += OptState(Opt[2], &ANSI);
   break;
  case 'd':
   optLen += OptState(Opt[2], &fDelay);
   break;
  case 'f':
   strdel(Opt, 0, 2); Font.W = decVal(Opt);
   if (Opt[0] != ',') Stop(2, Opt);
   strdel(Opt, 0, 1); Font.H = decVal(Opt);
   optLen = 0;
   break;
  case 'o':
   optLen += OptState(Opt[3], &State) + 1;
   switch (Opt[2])
   {
    case 'b': if (State)
               sd.FgBg = SSF_FGBG_BACK;
              else
               sd.FgBg = SSF_FGBG_FORE;
              break;
    case 'c': if (State)
               sd.PgmControl &= ~SSF_CONTROL_NOAUTOCLOSE;
              else
               sd.PgmControl |= SSF_CONTROL_NOAUTOCLOSE;
              break;
    case 'v': if (State)
               sd.PgmControl &= ~SSF_CONTROL_INVISIBLE;
              else
               sd.PgmControl |= SSF_CONTROL_INVISIBLE;
              break;
    case 'x': if (State)
              {
               sd.PgmControl |= SSF_CONTROL_MAXIMIZE;
               sd.PgmControl &= ~SSF_CONTROL_MINIMIZE;
              }
              else
               sd.PgmControl &= ~SSF_CONTROL_MAXIMIZE;
              break;
    case 'm': if (State)
              {
               sd.PgmControl |= SSF_CONTROL_MINIMIZE;
               sd.PgmControl &= ~SSF_CONTROL_MAXIMIZE;
              }
              else
               sd.PgmControl &= ~SSF_CONTROL_MINIMIZE;
              break;
     default: Stop(2, Opt);
   }
   break;
  case 'p':
   strdel(Opt, 0, 2); if (Opt[0] != ',') sd.InitXPos = decVal(Opt);
   if (Opt[0] == ',')
   {
    strdel(Opt, 0, 1); if (Opt[0] != ',') sd.InitYPos = decVal(Opt);
    if (Opt[0] == ',')
    {
     sd.PgmControl &= ~SSF_CONTROL_MAXIMIZE;
     strdel(Opt, 0, 1); if (Opt[0] != ',') sd.InitXSize = decVal(Opt);
     if (Opt[0] == ',')
     {
      strdel(Opt, 0, 1); sd.InitYSize = decVal(Opt);
     }
    }
   }
   optLen = 0;
   break;
  case 'q':
   fQueryCommand = TRUE;
   break;
  case 's':
   strdel(Opt, 0, 2); Console.W = decVal(Opt);
   if (Opt[0] != ',') Stop(2, Opt);
   strdel(Opt, 0, 1); Console.H = decVal(Opt);
   if (!fSecondLayer) progname = SourceName();
   optLen = 0;
   break;
  case 't':
   switch (Opt[2])
   {
    case 'a':
     sd.SessionType = SSF_TYPE_DEFAULT;
     break;
    case 'd':
     sd.SessionType = SSF_TYPE_WINDOWEDVDM;
     break;
    case 'o':
     sd.SessionType = SSF_TYPE_WINDOWABLEVIO;
     break;
    default:
     Stop(2, Opt);
   }
   optLen++;
   break;
  case '@':
   // "Undocumented" :-) switch for internal usage
   fSecondLayer = TRUE;
   break;
  case '?':
  case 'h':
   Stop(1, NULL);
  default:
   Stop(2, Opt);
 }
 if ((Opt[optLen] != 0) && (Opt[optLen] != SPACE) && (Opt[optLen] != TAB))
  Stop(2, Opt);
 return optLen;
}

int StrH(char *Str)
{
 int len;
 int sz;

 if (progname == NULL)
 {
  len = firstwordlen(Str);
  sz = strlen(Str) - len;
  progname = malloc(len + 1);
  Str[len] = 0;
  strcpy(progname, Str);
  if (!strcmp("*", progname)) progname[0] = 0;
  if (sz > 0)
  {
   progargs = malloc(sz + 1);
   strcpy(progargs, (char *)&Str[len + 1]);
  }
 } else
 {
  progargs = malloc(64 + strlen(Str) + 1);
  sprintf(progargs, "-@ -s%d,%d %s", Console.W, Console.H, Str);
  sd.SessionType = SSF_TYPE_WINDOWABLEVIO;
 }
 return 99999;
}

doShowCommand()
{
 char ch;

 SetColor(colLCYAN, colSAME);
 printf(" Effective command line:\nô ");
 SetColor(colWHITE, colSAME);
 switch (sd.SessionType)
 {
  case SSF_TYPE_DEFAULT:       ch = 'a'; break;
  case SSF_TYPE_WINDOWEDVDM:   ch = 'd'; break;
  case SSF_TYPE_WINDOWABLEVIO: ch = 'o'; break;
 }
 printf("wOpen -t%c -p%d,%d,%d,%d", ch,
        sd.InitXPos, sd.InitYPos, sd.InitXSize, sd.InitYSize);
 (sd.PgmControl & SSF_CONTROL_NOAUTOCLOSE) ? (ch = '-') : (ch = '+');
 printf(" -oc%c", ch);
 (sd.PgmControl & SSF_CONTROL_INVISIBLE) ? (ch = '-') : (ch = '+');
 printf(" -ov%c", ch);
 if (sd.PgmControl & SSF_CONTROL_MAXIMIZE)
  printf(" -ox+");
 if (sd.PgmControl & SSF_CONTROL_MINIMIZE)
  printf(" -om+");
 if (sd.FgBg = SSF_FGBG_BACK)
  printf(" -ob+");
 if (Font.W != -1)
  printf(" -f%d,%d", Font.W, Font.H);
 if (Console.W != -1)
  printf(" -s%d,%d", Console.W, Console.H);
 printf("\n");
}

void doExecute()
{
 static char zero[] = "";
 char objbuff[255];
 ULONG sid;
 PID pid;
 USHORT fMax;
 long Sz;

 sd.Length = sizeof(sd);
 sd.PgmName = progname;
 sd.PgmInputs = progargs;
 sd.InheritOpt = SSF_INHERTOPT_PARENT;
 sd.ObjectBuffer = (PVOID)&objbuff;
 sd.ObjectBuffLen = sizeof(objbuff);

 // Delete the shitty sInitialShape since it has a messy structure
 PrfWriteProfileData(HINI_USERPROFILE, "Shield", "sInitialShape",
     NULL, 0);
 if (sd.PgmControl & SSF_CONTROL_MAXIMIZE) fMax = 1; else fMax = 0;
 PrfWriteProfileData(HINI_USERPROFILE, "Shield", "fMaximize",
     (PVOID)&fMax, sizeof(fMax));
 PrfWriteProfileData(HINI_USERPROFILE, "Shield", "~Font Size...",
     (PVOID)&Font, sizeof(Font));

 switch (DosStartSession(&sd, &sid, &pid))
 {
  case NO_ERROR:
   SetColor(colLBLUE, colSAME);
   printf(" Session successfully started\n");
   break;
  default:
   SetColor(colLRED, colSAME);
   printf(" Failed because of \"%s\"\n", &objbuff);
 };
 if (fDelay) DosSleep(500);

 // Restore INI state
 if (INIpresent & iniShape) Sz = sizeof(DefShape); else Sz = 0;
 PrfWriteProfileData(HINI_USERPROFILE, "Shield", "sInitialShape",
     (PVOID)&DefShape, Sz);
 if (INIpresent & iniMaximize) Sz = sizeof(fMaximize); else Sz = 0;
 PrfWriteProfileData(HINI_USERPROFILE, "Shield", "fMaximize",
     (PVOID)&fMaximize, Sz);
 if (INIpresent & iniFontsize) Sz = sizeof(DefFont); else Sz = 0;
 PrfWriteProfileData(HINI_USERPROFILE, "Shield", "~Font Size...",
     (PVOID)&DefFont, Sz);
}

void doSetMode()
{
 char *arg;
 RESULTCODES rc;
 int i,j;

 SetConsoleSize(Console.W, Console.H, colSAME);

 if ((!progname) || (!progname[0])) progname = getenv("COMSPEC");
 if (progname) i = strlen(progname); else i = 0;
 j = i; i++;
 if (progargs) i+= strlen(progargs);
 arg = malloc(i);

 if (progname) strcpy(arg, progname); else arg[0] = 0;
 strcat(arg, "*");
 if (progargs) strcat(arg, progargs);
 arg[j] = 0;
 
 if (DosExecPgm(NULL, 0, EXEC_SYNC, arg, NULL, &rc, progname))
 {
  SetColor(colLRED, colSAME);
  printf("Error running command %s %s\n", progname, progargs);
  getch();
  return;
 }
}

int main (int argc, char *argv[])
{
 ULONG Sz;

 memset(sd, 0, sizeof(sd));
 Font.W = -1;
 Console.W = -1;
 sd.PgmControl = SSF_CONTROL_SETPOS;
 sd.Related = SSF_RELATED_INDEPENDENT;
 sd.SessionType = SSF_TYPE_WINDOWABLEVIO;

 Sz = sizeof(DefShape);
 if (PrfQueryProfileData(HINI_USERPROFILE, "Shield", "sInitialShape",
     (PVOID)&DefShape, &Sz))
 {
  INIpresent |= iniShape;
  sd.InitXPos = DefShape.WindowX;
  sd.InitYPos = DefShape.WindowY;
  sd.InitXSize = DefShape.WindowW;
  sd.InitYSize = DefShape.WindowH;
 }

 Sz = sizeof(fMaximize);
 if (PrfQueryProfileData(HINI_USERPROFILE, "Shield", "fMaximize",
     (PVOID)&fMaximize, &Sz))
 {
  INIpresent |= iniMaximize;
  if (fMaximize)
   sd.PgmControl |= SSF_CONTROL_MAXIMIZE;
 }

 Sz = sizeof(DefFont);
 if (PrfQueryProfileData(HINI_USERPROFILE, "Shield", "~Font Size...",
     (PVOID)&DefFont, &Sz))
 {
  INIpresent |= iniFontsize;
  Font = DefFont;
 }

 ParseCmdLine(getenv("WOPEN"), OptH, StrH);
 cmdLine = CmdLine(argc, argv);
 ParseCmdLine(cmdLine, OptH, StrH);
 free(cmdLine);

 doHeader();

 if (fQueryCommand)
  doShowCommand();

 if (progname)
  if (fSecondLayer)
   doSetMode();
  else
   doExecute();
 else
  if (!fQueryCommand) doHelp();

 if (!fSecondLayer)
 {
  SetColor(colBLUE, colSAME);
  printf(" Done\n");
  SetColor(colCYAN, colSAME);
 }
}
